/*
 * Copyright (c) 2000, Amnon BARAK (amnon@cs.huji.ac.il). All rights reserved.
 *
 *       MOSIX $Id: mos.h,v 1.6 2001/03/06 01:31:04 amnons Exp $
 *
 * Permission to use, copy and distribute this software is hereby granted 
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/*
 * Author(s): Ariel Rosenblatt
 * Code derived from previous work by Amnon Shiloh and Oren Laadan.
 */
#ifndef __mos__
#define __mos__

#include <libmosix.h>

int dadvise(int advice, int interval, int keep);

int msx_is_mosix();
int msx_is_configured();

int msx_get_overheads_number();

int msx_get_config(struct mosixnet *config, int len);
int msx_set_config(struct mosixnet *config, int len);

int msx_get_stay();
int msx_set_stay();
int msx_unset_stay();

int msx_get_lstay();
int msx_set_lstay();
int msx_unset_lstay();

int msx_get_block();
int msx_set_block();
int msx_unset_block();

int msx_get_quiet();
int msx_set_quiet();
int msx_unset_quiet();

int msx_get_tune();
int msx_set_tune();
int msx_unset_tune();

int msx_expel();

int msx_bring();

int msx_adm_get_speed();
int msx_set_speed(int speed);
int msx_adm_get_sspeed();
int msx_set_sspeed(int sspeed);

int msx_get_overheads(int *overheads, int len);
int msx_set_overheads(int *overheads, int len);

int msx_get_slowdecay();
int msx_set_slowdecay(int slowdecay);
int msx_get_fastdecay();
int msx_set_fastdecay(int fastdecay);

int msx_get_decayinterval();
int msx_set_decayinterval(int decayinterval);

int msx_get_mospe();
int msx_set_mospe(int mospe);

int msx_get_cpujob();
int msx_set_cpujob();

int msx_get_iojob();
int msx_set_iojob();

int msx_get_slow();
int msx_set_slow();

int msx_get_fast();
int msx_set_fast();

int msx_get_own(int *decay, int *period);
int msx_set_own(int decay, int period);

int msx_get_inherit();
int msx_set_inherit();
int msx_unset_inherit();

int msx_get_exec();
int msx_set_exec();
int msx_unset_exec();

int msx_get_execonce();
int msx_set_execonce();
int msx_unset_execonce();

int msx_set_clear();

int msx_get_info(int node, struct mosix_info *info, int len);
int msx_get_infos(struct mosix_info *infos, int len);

int msx_get_loads(int *loads, int len);
int msx_get_speeds(int *speeds, int len);
int msx_get_cpus(int *cpus, int len);
int msx_get_utils(int *utils, int len);
int msx_get_stata(int *stata, int len);
int msx_get_mems(int *mems, int len);
int msx_get_rmems(int *rmems, int len);
int msx_get_tmems(int *tmems, int len);

int msx_get_load(int node);
int msx_get_speed(int node);
int msx_get_cpu(int node);
int msx_get_mem(int node);
int msx_get_rmem(int node);
int msx_get_tmem(int node);
int msx_get_util(int node);
int msx_get_status(int node);

int msx_where_is(pid_t pid);
int msx_is_lock(pid_t pid);
int msx_get_cantmove(pid_t pid, char *buff, int len);
int msx_send(pid_t pid, int node);
int msx_get_nmigs(pid_t pid);
int msx_where_am_i();
int msx_self_is_lock();
int msx_lock();
int msx_unlock();
int msx_self_get_cantmove(char *buff, int len);
int msx_migrate(int node);
int msx_self_get_nmigs();
int msx_send_back_home(pid_t pid);
int msx_go_back_home();
#endif 
